var g1 = null;
var g2 = null;
var g3 = null;
var g4 = null;
var g5 = null;
var g6 = null;
var g7 = null;
var g8 = null;
var pctText1 = null;
var pctText2 = null;
var pctText3 = null;
var pctText4 = null;
var pctText5 = null;
var pctText6 = null;
var pctText7 = null;
var pctText8 = null;
var MAXGAUGEWIDTH = 92;
var timeout = null;
var nbCPU=0;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////               Edited on july 21th, 2009 by Nicolas PETRALIA              ///////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function LaunchTaskManager()
{
    System.Shell.execute(System.Environment.getEnvironmentVariable("SystemRoot") + "\\System32\\taskmgr.exe");
}

function init()
{
	if (System.Machine.CPUs.count < 8)
	{
		nbCPU = System.Machine.CPUs.count;
	}
	else
	{
		nbCPU = 8;
	}
	var tailleBackground = nbCPU * 30;
	setNewBackground(tailleBackground);
	
	switch(nbCPU)
	{
		case 8:
			g8 = bg.addImageObject("images/gauge.png", 32, 215);
			g8.opacity = 95;	
			bg.addImageObject("images/mask.png", 0, 210);
		case 7:
			g7 = bg.addImageObject("images/gauge.png", 32, 185);
			g7.opacity = 95;	
			bg.addImageObject("images/mask.png", 0, 180);
		case 6:
			g6 = bg.addImageObject("images/gauge.png", 32, 155);
			g6.opacity = 95;	
			bg.addImageObject("images/mask.png", 0, 150);
		case 5:
			g5 = bg.addImageObject("images/gauge.png", 32, 125);
			g5.opacity = 95;	
			bg.addImageObject("images/mask.png", 0, 120);
		case 4:
			g4 = bg.addImageObject("images/gauge.png", 32, 95);
			g4.opacity = 95;	
			bg.addImageObject("images/mask.png", 0, 90);
		case 3:
			g3 = bg.addImageObject("images/gauge.png", 32, 65);
			g3.opacity = 95;
			bg.addImageObject("images/mask.png", 0, 60);
		case 2:
			g2 = bg.addImageObject("images/gauge.png", 32, 35);
			g2.opacity = 95;
			bg.addImageObject("images/mask.png", 0, 30);
		case 1:
			g1 = bg.addImageObject("images/gauge.png", 32, 5);
			g1.opacity = 95;
			bg.addImageObject("images/mask.png", 0, 0);
	};
		
	
	switch(nbCPU)
	{
		case 8:
			pctText8 = bg.addTextObject("", "Arial Black", 9, "Color(255,220,220,220)", 2, 218);
			pctText8.addGlow("Color(255,255,255,255)", 2, 40);
			bg.addTextObject("Core 8", "Arial Black", 9, "Color(255,220,220,220)", 55, 218).addGlow("Color(255,255,255,255)", 2, 40);
		case 7:
			pctText7 = bg.addTextObject("", "Arial Black", 9, "Color(255,220,220,220)", 2, 188);
			pctText7.addGlow("Color(255,255,255,255)", 2, 40);
			bg.addTextObject("Core 7", "Arial Black", 9, "Color(255,220,220,220)", 55, 188).addGlow("Color(255,255,255,255)", 2, 40);
		case 6:
			pctText6 = bg.addTextObject("", "Arial Black", 9, "Color(255,220,220,220)", 2, 158);
			pctText6.addGlow("Color(255,255,255,255)", 2, 40);
			bg.addTextObject("Core 6", "Arial Black", 9, "Color(255,220,220,220)", 55, 158).addGlow("Color(255,255,255,255)", 2, 40);
		case 5:
			pctText5 = bg.addTextObject("", "Arial Black", 9, "Color(255,220,220,220)", 2, 128);
			pctText5.addGlow("Color(255,255,255,255)", 2, 40);
			bg.addTextObject("Core 5", "Arial Black", 9, "Color(255,220,220,220)", 55, 128).addGlow("Color(255,255,255,255)", 2, 40);
		case 4:
			pctText4 = bg.addTextObject("", "Arial Black", 9, "Color(255,220,220,220)", 2, 98);
			pctText4.addGlow("Color(255,255,255,255)", 2, 40);
			bg.addTextObject("Core 4", "Arial Black", 9, "Color(255,220,220,220)", 55, 98).addGlow("Color(255,255,255,255)", 2, 40);
		case 3:
			pctText3 = bg.addTextObject("", "Arial Black", 9, "Color(255,220,220,220)", 2, 68);
			pctText3.addGlow("Color(255,255,255,255)", 2, 40);
			bg.addTextObject("Core 3", "Arial Black", 9, "Color(255,220,220,220)", 55, 68).addGlow("Color(255,255,255,255)", 2, 40);
		case 2:
			pctText2 = bg.addTextObject("", "Arial Black", 9, "Color(255,220,220,220)", 2, 38);
			pctText2.addGlow("Color(255,255,255,255)", 2, 40);
			bg.addTextObject("Core 2", "Arial Black", 9, "Color(255,220,220,220)", 55, 38).addGlow("Color(255,255,255,255)", 2, 40);
		case 1:
			pctText1 = bg.addTextObject("", "Arial Black", 9, "Color(255,220,220,220)", 2, 8);
			pctText1.addGlow("Color(255,255,255,255)", 2, 40);
			bg.addTextObject("Core 1", "Arial Black", 9, "Color(255,220,220,220)", 55, 8).addGlow("Color(255,255,255,255)", 2, 40);
	};

    setContentText();
}

function setNewBackground(hauteur)
{
	var nHauteur = parseInt(hauteur, 10);
	var body = document.body;
	var background = document.getElementById("bg");
	
	body.style.height = nHauteur + "px";
	background.style.height = nHauteur + "px";
	
	var headerHeight=10;
	var sliceHeight=10;
	var footerHeight=10;
		
	var top = 0;
	
	background.addImageObject("images/bgHeader.png", 0, top);
	top+= headerHeight;
	
	var middlePartHeight = nHauteur - headerHeight - footerHeight;

	for(var i=0; i< middlePartHeight; i+= sliceHeight)
	{
		background.addImageObject("images/bgSlice.png", 0, top);
		top+= sliceHeight;	
	}

	background.addImageObject("images/bgFooter.png", 0, top);
} 

function setContentText()
{
    clearTimeout(timeout);
	
	switch(nbCPU)
	{
		case 8:
			var cpu8usage = Math.min(100,Math.max(0,Math.round(System.Machine.CPUs.item(7).usagePercentage)));
			setGImageWidth(g8, cpu8usage * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 30); 
			setTextValue(pctText8, cpu8usage + "%");	
		case 7:
			var cpu7usage = Math.min(100,Math.max(0,Math.round(System.Machine.CPUs.item(6).usagePercentage)));
			setGImageWidth(g7, cpu7usage * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 30); 
			setTextValue(pctText7, cpu7usage + "%");	
		case 6:
			var cpu6usage = Math.min(100,Math.max(0,Math.round(System.Machine.CPUs.item(5).usagePercentage)));
			setGImageWidth(g6, cpu6usage * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 30); 
			setTextValue(pctText6, cpu6usage + "%");
		case 5:
			var cpu5usage = Math.min(100,Math.max(0,Math.round(System.Machine.CPUs.item(4).usagePercentage)));
			setGImageWidth(g5, cpu5usage * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 30); 
			setTextValue(pctText5, cpu5usage + "%");	
		case 4:
			var cpu4usage = Math.min(100,Math.max(0,Math.round(System.Machine.CPUs.item(3).usagePercentage)));
			setGImageWidth(g4, cpu4usage * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 30); 
			setTextValue(pctText4, cpu4usage + "%");
		case 3:
			var cpu3usage = Math.min(100,Math.max(0,Math.round(System.Machine.CPUs.item(2).usagePercentage)));
			setGImageWidth(g3, cpu3usage * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 30); 
			setTextValue(pctText3, cpu3usage + "%");
		case 2:
			var cpu2usage = Math.min(100,Math.max(0,Math.round(System.Machine.CPUs.item(1).usagePercentage)));
			setGImageWidth(g2, cpu2usage * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 30); 
			setTextValue(pctText2, cpu2usage + "%");
		case 1:
			var cpu1usage = Math.min(100,Math.max(0,Math.round(System.Machine.CPUs.item(0).usagePercentage)));
			setGImageWidth(g1, cpu1usage * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 30); 
			setTextValue(pctText1, cpu1usage + "%");
	};
    
    timeout = setTimeout("setContentText()", 1000);
}


function setGImageWidth(obj, newWidth, originalWidth, leftPos)
{
    obj.width = newWidth;
    //there is a bug in vista's sidebar that occurs when scaling g:image objects. this function applies a workaround for correct positioning
    //if the bug is fixed (it hasn't been in sp1) this gadget will look bad until the following line is removed:
    obj.left = leftPos - (originalWidth - newWidth) / 2;
}


function setTextValue(obj, newText)
{
    obj.value = newText;
    //workaround for text bounds not resizing automatically when text changes
    obj.width = 0;
    obj.height = 0;
    //center text
    obj.left = 32 - obj.width;
}